Last Comment Bug 720300 - Awesome bar shouldn't start search on Enter key pressed if there is composition string
: Awesome bar shouldn't start search on Enter key pressed if there is compositi...
Status: VERIFIED FIXED
[HKB]
:
Product: Firefox for Android
Classification: Client Software
Component: Keyboards and IME (show other bugs)
: unspecified
: All Android
: P3 normal (vote)
: Firefox 14
Assigned To: Chris Peterson [:cpeterson]
:
Mentors:
Depends on: 737653
Blocks:
  Show dependency treegraph
 
Reported: 2012-01-22 21:46 PST by Makoto Kato [:m_kato]
Modified: 2012-05-21 10:05 PDT (History)
6 users (show)
ryanvm: in‑testsuite?
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
fixed
verified
verified
+
11+


Attachments
bug-720300-awesomebar-composition-string.patch (4.26 KB, patch)
2012-03-22 17:50 PDT, Chris Peterson [:cpeterson]
blassey.bugs: review+
m_kato: review+
akeybl: approval‑mozilla‑aurora+
Details | Diff | Review

Description Makoto Kato [:m_kato] 2012-01-22 21:46:16 PST
When there is composition string on awesome bar, if you press "enter key", Fennec native will start search or URL navigation.

On stock browser or Fennec XUL, if there is composition string, "enter key" means commiting string.

When there is composition string, we should commit text if entry key is pressed.
Comment 1 Alex Pakhotin (:alexp) 2012-02-14 14:25:51 PST
This bug is a side-effect of the fix for bug 705939.
The keyboard handling in the Awesomebar is a bit hacky. Due to some internal specifics of the UI controls used for that screen the edit box sometimes loses its focus, and we cannot handle the input properly in some cases. The bug 702995 was filed to investigate this, but there is still no solution. The issues appearing are being patched, but those workarounds may cause other problems, and here's one of such examples.
We may try to add another check into onKeyPreIme listener to handle this specific situation here: http://mxr.mozilla.org/mozilla-central/source/mobile/android/base/AwesomeBar.java#168
Though I'm not sure yet if it's possible to check the current composition state.
Comment 2 Chris Peterson [:cpeterson] 2012-02-27 10:20:30 PST
I think this bug should be a fennec-1.0 blocker because it prevents the user from entering a URL.
Comment 3 Chris Peterson [:cpeterson] 2012-03-20 15:00:29 PDT
This bug may depend on bug 737653.
Comment 4 Chris Peterson [:cpeterson] 2012-03-21 15:53:44 PDT
Makoto, can you still reproduce this bug? I tested Google Japanese Input method on my Galaxy Nexus and Samsung S2, but I can't reproduce the problem.
Comment 5 Makoto Kato [:m_kato] 2012-03-21 23:33:02 PDT
(In reply to Chris Peterson (:cpeterson) from comment #4)
> Makoto, can you still reproduce this bug? I tested Google Japanese Input
> method on my Galaxy Nexus and Samsung S2, but I can't reproduce the problem.

Google Japanese Input doesn't support Hardware keyboard.  Try Shimeji or OpenWnn on HTC Desire Z.
Comment 6 Naoki Hirata :nhirata (please use needinfo instead of cc) 2012-03-22 14:25:56 PDT
Simeji reproduces the issue on any device.  cpeterson, if you're in SF Office, I can show you in person.
Comment 7 Chris Peterson [:cpeterson] 2012-03-22 17:50:45 PDT
Created attachment 608548 [details] [diff] [review]
bug-720300-awesomebar-composition-string.patch

Don't submit AwesomeBar text when there is an active composition string.

This patch generalizes Makato-san's fix for bug 715207 so we can check for a composition string when processing ENTER keydown events. This bug only affects HKB.
Comment 8 Chris Peterson [:cpeterson] 2012-03-22 17:54:44 PDT
oops: Makoto, not "Makato"! <:)
Comment 9 Chris Peterson [:cpeterson] 2012-03-26 10:42:12 PDT
checkin-needed for mozilla-central
Comment 10 Chris Peterson [:cpeterson] 2012-03-26 10:44:55 PDT
Comment on attachment 608548 [details] [diff] [review]
bug-720300-awesomebar-composition-string.patch

[Approval Request Comment]
Regression caused by (bug #): bug 705939
User impact if declined: Multibyte text input will not work in AwesomeBar.
Testing completed (on m-c, etc.): 
Risk to taking this patch (and alternatives if risky): AwesomeBar text input.
String changes made by this patch: None
Comment 11 Alex Keybl [:akeybl] 2012-03-26 13:48:43 PDT
Comment on attachment 608548 [details] [diff] [review]
bug-720300-awesomebar-composition-string.patch

[Triage Comment]
Mobile only - approved for Aurora 13.
Comment 12 Ryan VanderMeulen [:RyanVM] 2012-03-26 17:47:57 PDT
https://hg.mozilla.org/integration/mozilla-inbound/rev/6ad4454a4c83
Comment 13 Ed Morley [:emorley] 2012-03-27 05:18:52 PDT
https://hg.mozilla.org/mozilla-central/rev/6ad4454a4c83
Comment 14 Chris Peterson [:cpeterson] 2012-03-27 10:27:23 PDT
checkin-needed for mozilla-aurora
Comment 16 Cristian Nicolae (:xti) 2012-05-21 10:05:48 PDT
Verified fixed on:

Firefox 15.0a1 (2012-05-21)
Firefox 14.0a2 (2012-05-21)

Device: Galaxy Nexus
OS: Android 4.0.2

Note You need to log in before you can comment on or make changes to this bug.